#*************************************************************
# Progamm:			eiskugel
# Sinn des Programms: 		Berechnung des Preises einer Trittin'schen Kugel Eis
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		eiskugel_haupt.py
# Versionsnummer:		1
# Wird aufgerufen von:		-
# Ruft auf:			eingabe.py, rechner.py
# Nummer im Programmpaket:	1
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			07.01.2019
# Letzte Änderung: 		04.02.2021
#*************************************************************


#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************

import time
import datetime

#*************************************************************
# Importieren der Klassen
#*************************************************************

from eingabe import Eingabe
eingabe = Eingabe()

from rechner import Rechner
rechner = Rechner()

from ausgabe import Ausgabe
ausgabe = Ausgabe()  

dt_start = datetime.datetime.now()
lt_start = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
datum_zeit = "Datum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)

#*************************************************************
# Öffnen der Logdatei
#*************************************************************
fobj_log = open("eiskugel.log","w")
fobj_log.write("Anfang: "+ "\n" + datum_zeit)
fobj_log.write("\n")


#*************************************************************
# Test ob Eingabefunktion funktionierte
#*************************************************************
if eingabe.einlesen():
  #*************************************************************
  # Schirm- und Dateiausgabe beim Funktionieren der Eingabe
  #*************************************************************
  print("Eingabe funktionierte!")
  fobj_log.write("Eingabe funktionierte!"+"\n")

  

  if rechner.rechner(eingabe.kosten_deutschland,eingabe.einwohner_deutschland,eingabe.personen_pro_haushalt) :
    print("Rechnung funktionierte!")
    fobj_log.write("Rechnung funktionierte!"+"\n")
    
    if eingabe.schirm_ausgabe_wähler :
      if ausgabe.schirm_ausgabe(eingabe.kosten_deutschland,rechner.kosten_person,rechner.kosten_haushalt,rechner.kosten_eiskugel):
        print("Schirm-Ausgabe funktionierte!")
        fobj_log.write("Schirm-Ausgabe funktionierte!"+"\n")
      else:
        print("Fehler in Schirm-Ausgabe!") 
        fobj_log.write("Fehler in Schirm-Ausgabe!"+"\n")  
    if eingabe.datei_ausgabe_wähler :
      if ausgabe.datei_ausgabe(eingabe.ausgabe_datei, eingabe.kosten_deutschland,rechner.kosten_person,rechner.kosten_haushalt,rechner.kosten_eiskugel):
        print("Datei-Ausgabe funktionierte!")
        fobj_log.write("Datei-Ausgabe funktionierte!"+"\n")
      else:
        print("Fehler in Datei-Ausgabe!") 
        fobj_log.write("Fehler in Datei-Ausgabe!"+"\n")  
  #*************************************************************
  # Test ob Rechenfunktion funktionierte
  #*************************************************************
    if ausgabe.gui(rechner.kosten_person, rechner.kosten_haushalt, rechner.kosten_eiskugel):
    #*************************************************************
    # Schirm- und Dateiausgabe beim Funktionieren
    #*************************************************************
      print("GUI-Ausgabe funktionierte!")
      fobj_log.write("GUI-Ausgabe funktionierte!"+"\n")
    else:
    #*************************************************************
    # Schirm- und Dateiausgabe bei Fehler
    #*************************************************************
      print("Fehler in GUI-Ausgabe!") 
      fobj_log.write("Fehler in GUI-Ausgabe!"+"\n")
  else:
    print("Fehler in Rechnung!")
    fobj_log.write("Fehler in Rechnung!"+"\n")
else:
  #*************************************************************
  # Schirm- und Dateiausgabe bei Fehler in Eingabe
  #*************************************************************
  print("Fehler in Eingabe!")
  fobj_log.write("Fehler in Eingabe!"+"\n")


#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit"
#*************************************************************
lt_end = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
datum_zeit = "Datum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
dauer = dt_end - dt_start

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
fobj_log.write("Ende: "+ "\n" +datum_zeit + "\n")
fobj_log.write("Rechendauer: "+ "\n" + str(dauer))

#*************************************************************
# Schließen der Logdatei
#*************************************************************

fobj_log.close()

#*************************************************************
#Programmende
#*************************************************************


